import java.*;
import java.io.*;
import java.util.*;
import java.util.ArrayList;
import java.lang.*;

public class Cable{

	public static void main(String args[]) throws Exception{
	
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		Cable inst = new Cable();
		
		String line;
		while( (line = br.readLine()) != null ){
				
				int N = Integer.parseInt(line);
				String[] inputs = new String[N];
		
				for(int i = 0; i <N; i++){
					inputs[i] = br.readLine();
				}
				inst.run(inputs);
		}
		
	}
	
	public Cable(){
	}
	
	public void run(String[] inputs){
		List<Point> list = this.createList(inputs);
		Point MAX = this.findMax(list);
		System.out.println(this.findShortestPath(MAX, list));
	}
	
	public double findShortestPath(Point p, List<Point> l){
		double c, k, alfarad,result = 0.0, path = 0.0;
		for(double Alfa = 1.0; Alfa < 180.0; Alfa += 0.5){
			alfarad = Math.toRadians((double)Alfa);
			k = Math.tan(alfarad);
			c = (double)p.getY() + alfarad*(double)p.getX();
			path = Math.sqrt(c*c+(c*c/alfarad*alfarad));
			if(this.checkPath(l,k,c)){
				result = path;
			} 
		}
		return result;
	}
	
	public boolean checkPath(List<Point> list, double k, double c){
		boolean noconflict = true;
		double ypsilon;
		for(int i = 0; i < list.size(); i++){
			ypsilon = k*(double)list.get(i).getX() + c;
			if((double)list.get(i).getY() > ypsilon){
				noconflict = false;
				break;
			}
		}
		return noconflict;
	}

	public Point findMax(List<Point> inputList){		
		Point p = new Point(0,0);		
		for(int i = 0; i < inputList.size(); i++){
			if( p.getDistance() < inputList.get(i).getDistance() ){
				p = inputList.get(i);
			}
		}
		return p;
	}


	public List<Point> createList(String[] inputarr){
		List<Point> results = new ArrayList<Point>();
		
		for(int i=0; i < inputarr.length; i++){
			String[] parsed = inputarr[i].split(" ");		
			results.add(new Point( Integer.parseInt(parsed[1]), Integer.parseInt(parsed[0]) ));			
		}
		return results;
	}	


	
	
	public class Point{
		int _X;
		int _Y;
		double _distance;
		
		public Point(){
		}
		
		public Point(int x, int y){
			this._X = x;
			this._Y = y;
			this._distance = Math.sqrt( (double)((x*x) + (y*y)) );
		}

		
		public double getDistance(){
			return this._distance;
		}
		public int getX(){
			return this._X;
		}
		public int getY(){
			return this._Y;
		}	
	}	
}
